#ifndef _PPONGO_H_
#define _PPONGO_H_

// --------------------------------------------------------------------
//	
// Structure Definitions
//	
// --------------------------------------------------------------------**/

typedef struct _TERM_SCREEN 
{
	USHORT	NumRows;		// Total number of rows in the buffer
	USHORT	NumCols;		// Total number of columns in the buffer
	USHORT	TopRow;			// Top-most row visible on the screen
	USHORT	LeftCol;		// Left-most column visible on the screen		
	USHORT	ScreenRows;		// Number of rows visible on the screen
	USHORT	ScreenCols;		// Number of columns visible on the screen
	USHORT	CursorRow;		// Row of the cursor
	USHORT	CursorCol;		// Column of the cursor
	USHORT	CharHeight;		// Character Width
	USHORT	CharWidth;		// Character Hieght
	BOOL	HaveFocus;		// Do we have focus?
	PTCHAR	ScreenBuff;		// The screen buffer
} TERM_SCREEN, *PTERM_SCREEN;

#define	ON_SCREEN(row,col)	(((row) >= Screen.TopRow) && \
	((row) < Screen.TopRow+Screen.ScreenRows) && \
	((col) >= Screen.LeftCol) && \
	((col) < Screen.LeftCol+Screen.ScreenCols) ? TRUE : FALSE)

#define ROWY(row)		(((row) - Screen.TopRow)*Screen.CharHeight)
#define COLX(col)		(((col) - Screen.LeftCol)*Screen.CharWidth)
#define SCREENPOS(r,c)	(Screen.ScreenBuff[((r)*(Screen.NumCols+1))+(c)])
#define CURPOS			(Screen.ScreenBuff[(Screen.CursorRow*(Screen.NumCols+1))+Screen.CursorCol])

// Initial screen values
#define	INIT_SCREEN_COLS	80
#define INIT_SCREEN_ROWS	25

	
// --------------------------------------------------------------------
//	
// Global Variables
//
// --------------------------------------------------------------------
extern HWND			hMainWnd;
extern HWND			hTermWnd;
extern HFONT		v_hFont;
extern TERM_SCREEN	Screen;			// The global screen
extern HANDLE		v_hThreadStopped;
extern BOOL			v_bStopThread;
extern TCHAR		v_szDevName[];
extern HANDLE		hPort;			// The serial port handle.

// --------------------------------------------------------------------
//	
// Function declarations
//
// --------------------------------------------------------------------

// settings.c
LRESULT CALLBACK CommDlgProc (HWND hDlg, UINT message, WPARAM wParam,
							  LPARAM lParam);

// screen.c
void ClearScreen ();
void FillScreen();
void PaintScreen (HWND hWnd, HDC hDC, RECT *pRect);
void InvalidateChar (HWND hWnd);
BOOL InitScreenSettings (HWND hWnd);
void ProcessChar (BYTE InByte);
void ScrollDown (int Rows);
void ScrollRight (int Cols);

// port.c
DWORD WINAPI	ReadThread (LPVOID pvarg);
void			PortWrite (BYTE Byte);
BOOL			InitPort (void);
BOOL			OpenPort(void);
BOOL			ClosePort (void);
void			PrintDCB (HANDLE hPort);

// ppongo.c
void			SetLightIndicators (DWORD fdwCommModemStatus);

#endif // _PPONGO_H_
